<script setup>
    import {ref} from 'vue'
    import { HttpReq } from '@/utilies/httpRequest';

    const dialogPDF = ref(false)
    const props = defineProps(['orders'])
    const emits = defineEmits(['saveLabel'])

    const itemId = ref("")

    function openModal(id) {
        itemId.value = id
        dialogPDF.value = true;
    }

    function downloadGuide() {
        let indexOrder = props.orders.findIndex(itemOrder => itemOrder.id == itemId.value)
        let base64Pdf = indexOrder >= 0 ? props.orders[indexOrder].generateGuide.pdfGuide : ''
        const pdfWindow = window.open("");
        pdfWindow.document.write(`<iframe width='100%' height='100%' src='data:application/pdf;base64,${base64Pdf}'></iframe>`);
    }

    async function downloadLabel() {
        let indexOrder = props.orders.findIndex(itemOrder => itemOrder.id == itemId.value)
        
        if( indexOrder < 0) {
            console.log("error no found")
            return
        }
        let base64Pdf = props.orders[indexOrder].generateLabel.labels ? props.orders[indexOrder].generateLabel.labels : ""

        if(!base64Pdf) {
            let resp = await HttpReq.getData(`soap/printlabel/${props.orders[indexOrder].id}/${props.orders[indexOrder].generateGuide.codeRemission}`)
            console.log("Consulta: ", resp)
            if(resp.status == 200) {
                emits('saveLabel', itemId.value, resp.data)
                base64Pdf = resp.data.labels
            } else {
                console.log("error")
                return
            }
        }
        const pdfWindow = window.open("");
        pdfWindow.document.write(`<iframe width='100%' height='100%' src='data:application/pdf;base64,${base64Pdf}'></iframe>`);
        dialogPDF.value = false
    }

    defineExpose({
        openModal
    })
</script>

<template>
    <v-row justify="center">
        <v-dialog
        v-model="dialogPDF"
        max-width="450"
        >
            <v-card>
                <v-card-title class="text-h5">
                    Generador de PDF
                </v-card-title>
                <v-card-text>
                    <v-row>
                        <v-col cols="2">

                        </v-col>
                        <v-col cols="3">
                            <v-btn
                                @click="downloadGuide"
                                >
                                Guía
                                <v-icon
                                    right
                                    dark
                                >
                                    mdi-file-download
                                </v-icon>
                            </v-btn>
                        </v-col>
                        <v-col cols="2">

                        </v-col>
                        <v-col cols="3">
                            <v-btn
                                @click="downloadLabel"
                                >
                                Rotulo
                                <v-icon
                                    right
                                    dark
                                >
                                    mdi-file-download
                                </v-icon>
                            </v-btn>
                        </v-col>
                        <v-col cols="2">

                        </v-col>

                    </v-row>
                    
                    
                </v-card-text>
                <v-card-actions>
                    <v-spacer></v-spacer>
                    <v-btn
                        color="primary"
                        text
                        @click="dialogPDF = false"
                    >
                        Cerrar
                    </v-btn>

                </v-card-actions>
            </v-card>
        </v-dialog>
    </v-row>
</template>

<style>

</style>